	/*
	 *********************************************************************************
	 *		allinput.cpp                             
	 *		r20010330
	 *		
	 *		2001 by Emu10k1 Independent Programmers
	 *		http://go.to/emu10k1
	 *
	 *********************************************************************************
	 */

// link it with eapshrm.lib
	
#include "aps15api.h"
#include "windows.h"
#include "iostream.h"

int main() {

	long portsid, inpid, rv;
	short ich;

	// let's create our own portsid (with all inputs and outputs)
	rv = fxPgmCreatePortID(0x2001, CI_ALL, CO_ALL, &portsid); // 0x2001 is chip id (in most cases)
	
	if (rv != 0) goto error;

	// check if mixer is running
	rv = fxPgmIsRunning(0x4002); // Mixer program Id should be 0x4002 if all is ok

	if (rv != 1) goto error;

	// OK, All Right, so here we go:
	cout << endl << "All Inputs example utility by EIP" << endl
		 << "http:/go.to/emu10k1" << endl << endl;
again:

	cout << "Please, select one of the emu10k1 chip inputs" << endl
		 << "to connect it to the Analog In 3+4 strips of Econtrol:" << endl
		 << endl;

	cout << '\t' << "0. AC97 Codec , APS Analog In 1+2, Chip Pin 8" << endl;
	cout << '\t' << "1. CD SPDIF In, APS Digital In 1 , Chip Pin 122" << endl;
	cout << '\t' << "2. PC DVD IN ?, None             , ?" << endl;
	cout << '\t' << "1.              APS Digital In 2 , Chip Pin 123" << endl;
	cout << '\t' << "4.            , APS Analog In 3+4, Chip Pin 106" << endl;
	cout << '\t' << "5. ?" << endl;
	cout << '\t' << "6. ??" << endl;
	cout << '\t' << "7. ???" << endl;

	cout << '\t' << "9. Exit" << endl;

	cin  >> (long) inpid;

	if (inpid == 9) 
		{
		rv = fxPgmFreePortID(portsid);	// destroy "ports" program we created above
		return 0;
		}
	
	// Well, let's connect selected inputs to Analog In 3+4 strips:

	ich = 16 + inpid * 2; // see "default aps microcode memory map.txt" for input channels indexes
	rv = fxPatchChannel(portsid, ich, 0x4002, 0x08);   // connects left channel of input we selected
													   // to Mixer (ox4002) Analog In 3 strip (0x08)
	rv = fxPatchChannel(portsid, ich+1, 0x4002, 0x09); // connects right channel of input we selected
													   // to Mixer (ox4002) Analog In 4 strip (0x09)

	// it's always works! (since we created portsid and check if mixer is running)
	cout << endl << "Successfuly connected..." << endl << endl;

	goto again;

	return 0;

error:
	cout << "Sorry, I can't run properly! Check if APS Drivers are installed" << endl
		 << "and Sscene is running." << endl;

	return 0;

	}

	