/*
	 *********************************************************************************
	 *		imeffect.cpp                              
	 *		r20010330
	 *		
	 *		2001 by Emu10k1 Independent Programmers
	 *		http://go.to/emu10k1
	 *
	 *********************************************************************************
	 *		THIS FILE IS PROVIDED WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES 
	 *		OF ANY KIND, INCLUDING BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES 
	 *		OF FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY OR TITLE.
	 *		SINCE THIS SOURCE CODE USES COMMERCIAL SOFTWARE LIBRARIES OWNED BY
	 *		CREATIVE AND/OR EMU-ENSONIQ AND PROTECTED BY COPYRIGHT LAWS AND
	 *		INTERNATIONAL TREATY PROVISIONS YOU MAY USE THIS CODE ONLY FOR 
	 *		EDUCATIONAL PURPOSES ONLY.
	 *	    ANY OTHER USES WILL BE TREATED BY CREATIVE AND EMU/ENSONIQ AS A
	 *		PIRACY                                                     
	 *	
	 *********************************************************************************
	 */


#include "aps15api.h"
#include "windows.h"
#include <iostream>
#include <strstream>
#include <fstream>
using namespace std;

ofstream fout("imeffect.txt");	//outputs to this file
streampos beforecout;

//Macros to output to both file and console
#define bout(shout) beforecout = shout.tellg(); cout << shout.rdbuf(); shout.seekg(beforecout); fout << shout.rdbuf()
	
	
int main()
{
	PGMQUERY PgmInfo;
	E10FXINSTR Inst = {0, 0, 0, 0, 0, 0};
	strstream shout;
	long id, hr;

	char Opcodes[16][8]=
	{
		"MACS",
		"MACS1",
		"MACW",
		"MACW1",
		"MACINTS",
		"MACINTW",
		"ACC3",
		"MACMV",
		"ANDXOR",
		"TSTNEG",
		"LIMIT",
		"LIMIT1",
		"LOG",
		"EXP",
		"INTERP",
		"SKIP"
	};

	shout << endl << "I'm Effect example utility by EIP" << endl
		<< "http:/go.to/emu10k1" << endl;
	bout(shout);
	cout << "(outputs to file imeffect.txt)" << endl;

enter:
	shout.setf(ios::uppercase);
	cout << endl << "Enter effect index from 1 to 99, or 0 to exit:" << dec << endl;

	cin >> (long) id;

	if (id >= 100) goto enter;

	switch (id)
	{
	case 0:
		fout.close();
		return 0;

	default:
		hr = fxPgmQueryProgram(id | FXPROGRAM_BASE, &PgmInfo);
		if (hr != APS_SUCCESS) 
		{
			cout << "Sorry, can't find program with index " << id << endl;
			goto enter;
		}

		shout << endl << "FX Program " << id << " info" << endl
			<< '\t' << "Microcode offset: " << '\t' << '\t' << "0x" << hex << PgmInfo.CodeOffset << endl
			<< '\t' << "Number of instructions: " << '\t' << dec << PgmInfo.Instructions << endl
			<< '\t' << "General Purpose Registers: " << '\t' << dec << PgmInfo.StaticRegs << endl
			<< '\t' << "Internal Tram" << endl
			<< '\t' << '\t' << "Offset: " << '\t' << '\t' << "0x" << hex << PgmInfo.ITramOffset << endl
			<< '\t' << '\t' << "Size: " << '\t' << '\t' << '\t' << "0x" << hex << PgmInfo.ITramSize << endl
			<< '\t' << '\t' << "Access Pairs: " << '\t' << '\t' << dec << PgmInfo.ITramPairs << endl
			<< '\t' << "External Tram" << endl
			<< '\t' << '\t' << "Offset: " << '\t' << '\t' << "0x" << hex << PgmInfo.XTramOffset << endl
			<< '\t' << '\t' << "Size: " << '\t' << '\t' << '\t' << "0x" << hex << PgmInfo.XTramSize << endl
			<< '\t' << '\t' << "Access Pairs: " << '\t' << '\t' << dec << PgmInfo.XTramPairs << endl;

		fout << "--------";
		bout(shout);

		shout << endl << "Microcode (Op A X Y R): " << hex << endl;
		bout(shout);	
		for (short i = 0; i < PgmInfo.Instructions; i++)
		{
			hr = fxParamReadInstruction( id, i, Inst);
			shout << '\t' << Opcodes[Inst.Opcode] << '\t' 
				<< "0x"  << Inst.A 
				<< " 0x" << Inst.X 
				<< " 0x" << Inst.Y 
				<< " 0x" << Inst.R << endl;
			bout(shout);
		}

		goto enter;
	}
	return 0;
}

