/*
*********************************************************************************
*		aps15api.cpp                              
*		r20010330
*		
*		2001 by Emu10k1 Independent Programmers
*		http://go.to/emu10k1
*
*********************************************************************************
*		
*		Date			Author		Summary of changes
*		----			------		------------------
*		January 7, 2001		Max M.		just plan for a future
*		February 13, 2001			a lot of new functions;
*							static linkage to dlls
*		March 30, 2001				public preparations
*
*		You must link yourself with eapshrm.lib and eapssrm.lib,
*
*********************************************************************************
*		THIS FILE IS PROVIDED WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES 
*		OF ANY KIND, INCLUDING BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES 
*		OF FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY OR TITLE.
*		THIS IS OPEN-SOURCE CODE, TO BE USED FOR EDUCATIONAL PURPOSES ONLY.        
*	
*********************************************************************************
*/
	 
#include "aps15api.h"

// these "constants" used in most of aps15api
// functions

long HWID_HRM;
long HWID_ECARD;
long HWID_EDRIVE = 0x00;	// it's always 0x00 on SBLive!
long HWID_MULTIOUT = 0x00;	// it's always 0x00 on SBLive!
long HWID_CHIP;

/* Gets required E-mu Hardware Handles */
long hrmInitHwIds(void)
	{
		
		long hr;

		
		hr = hrmGetHardwareInstances(0x01, &HWID_HRM);
		//On my CT4832 returns 0x01 in hr
		//and 0xB00B1E50 in HWID_HRM
		if (hr == 0x00)
				return APS_ERR_HARDWARE;

		hr = mxrGetHardwareInstances(0x01, &HWID_ECARD);
		//On my CT4832 returns 0x03 in hr
		//and 0xCADE0000 in HWID_ECARD
		if (hr == 0x00)
				return APS_ERR_HARDWARE;

		//ChipID is always 0x2001 but who knows...
		HWID_CHIP = hrmGetFXID(HWID_HRM);
		
		if (hr == 0x00)
				return APS_ERR_HARDWARE;

		return APS_SUCCESS;

	}
