	/*
	 *********************************************************************************
	 *		aps15api.h                              
	 *		r20010330
	 *		
	 *		2001 by Emu10k1 Independent Programmers
	 *		http://go.to/emu10k1
	 *
	 *********************************************************************************
	 *		
	 *		Date			Author		Summary of changes
 	 *		----			------		------------------
	 *		January 7, 2001		Max M.		just plan for a future
	 *		February 13, 2001			a lot of new functions;
	 *							static linkage to dlls
	 *		March 30, 2001				public preparations
	 *
	 *		You must link yourself with eapshrm.lib and eapssrm.lib,
	 *		shipped with Aps15api package
	 *
	 *********************************************************************************
	 *		THIS FILE IS PROVIDED WITHOUT ANY EXPRESSED OR IMPLIED WARRANTIES 
	 *		OF ANY KIND, INCLUDING BUT NOT LIMITED TO, ANY IMPLIED WARRANTIES 
	 *		OF FITNESS FOR A PARTICULAR PURPOSE, MERCHANTABILITY OR TITLE.
	 *		THIS IS OPEN-SOURCE CODE, TO BE USED FOR EDUCATIONAL PURPOSES ONLY. 
	 *	
	 *********************************************************************************
	 */

	/* 
	OK guys, i guess that
		HRM is Hardware Resource Manager
		SRM is Software Resource Manager
	and here we go...
	*/

	#include "windows.h"

	#ifndef _APS15API_
	#define _APS15API_

	/* FxEngine Structures */

	/* Note on E10FXINSTR struct:
	to use properly original struct we should build with 1 byte alignment,
	but it is realy unwanted so i added "_unused" member to correct
	members alignment and defined wrap macros to use this struct as 
	argument to instr read/write functions */
	typedef struct {
		char  _unused;	// contains garbage
		char  Opcode;
		short R;
		short A;
		short X;
		short Y;
		} E10FXINSTR; 

	typedef struct {          
		char op[9];   
		} E10FXINSTRB;

	// this struct is used in fxPgmQueryProgram
	typedef struct {
		short CodeOffset;	// microcode offset
		short Instructions;	// number of instructions
		long ITramOffset;	// start offset of allocated internal tram
		long ITramSize;	    // size of allocated internal tram
		long XTramOffset;	// for external tram
		long XTramSize;
		long Unk1;			// same as rsrc Reserved1 ??
		long Unk2;			// same as rsrc Reserved2 ??
		short StaticRegs;	// number of static registers (including outputs),
							// same as rsrc Unknown1 + Outputs 
		short ITramPairs;	// number of itram accesses, same as rsrc Unknown3	
		short XTramPairs;	// number of xtram accesses, same as rsrc Unknown4		
		} PGMQUERY;		

	// this struct is used in fxRsrcQueryChip
	typedef struct {          
		short unknown[11];   // i'v seen only 0x0A in unknown[11]
		} CHIPQUERY;

	// this struct is used in fxRsrcQueryPartition
	// Note: same thing as with E10FXINSTR (needs 2 bytes alignment)
	typedef struct {
		short _unused;		// contains garbage
		short Instructions;	// number of free instructions
		long  ITram;		// free itram memory
		long  XTram;		// free xtram memory
		long  Unk;	        // i don't remember now, later...
		short GPR;			// free general purpose registers
		short ITramPairs;	// free itram accesses		
		short XTramPairs;	// free xtram accesses	
		short ChipVer;		// Chip revision/version - 0x0A
		} PRTNQUERY;

	// see previous struct
	typedef struct {          
		short PrtnInfo[11];
		} PRTNQUERYB;

	// this struct is used in fxRsrcAllocPartition
	typedef struct {
		short GPR;			// 0x00ee		for 10k1 (other for interpolators)
		short ITramPairs;	// 0x0080		for 10k1
		short XTramPairs;	// 0x0020		for 10k1
		short Instructions;	// 0x01f8		for 10k1 (other for interpolators)
		long  ITram;		// 0x00002000	for 10k1 (~0.170 sec)
		long  XTram;		// 0x00040000	for 10k1
							// ~5.461 sec, but ~21.845 sec seems possible (0x00100000)
		long  Unk1;			// 0x00000000	for 10k1 
		} PRTNRSRC;  // hehe, means "Partition Resources"


	extern "C" // extern "C" because of not native lib files
	{

	/* Eapshrm.dll Functions */

	/* Arguments Naming Conventions
		ChipId - Chip ID (in most cases 0x2001)
		PrtnId - Partition ID (in most cases 0x8001)
		PgmId - Program ID
		RegId - Register ID
		InstrId - Instruction ID
		et. - ;)					*/

	long _cdecl fxParamReadGPR(long PgmId, short RegId);
	long _cdecl fxParamWriteGPR(long PgmId, short RegId, long Value);

	long _cdecl fxParamInterpolate(long PgmId, short RegId, long Value);
	long _cdecl fxParamStopInterpolator(long PgmId, short RegId);
	long _cdecl fxParamStopAllInterpolators(long PgmId);

	/* InstrField = Field | Instr (see Field Flags defines) */
	long _cdecl fxParamReadInstructionField(long PgmId, short InstrField);
	long _cdecl fxParamWriteInstructionField(long PgmId, short InstrField, short RegId);


	long _cdecl fxParamReadInstructionB(long PgmId, short InstrId, E10FXINSTRB* pInstrB); // see E10FXINSTR struct note
	
	// Dunno, does not work as i expected 
	long _cdecl fxParamReadTRAMAddress(long PgmId, short RegId);

	// Dunno, sometimes works properly, sometimes does not
	long _cdecl fxParamWriteTRAMAddress(long PgmId, short RegId, long Value); // Never use Value=0x0, after that function does not work anymore, dunno why...
	
	long _cdecl fxParamReadFlags(long PgmId, short RegId);
	long _cdecl fxParamWriteFlags(long PgmId, short RegId, long Value);
	

	long _cdecl fxPatchChannel(long PgmA, short OutCh, long PgmB, short InCh);
	long _cdecl fxPatchGroundInput(long PgmId, short ChnId);
	long _cdecl fxPatchGroundOutput(long PgmId, short ChnId);
	long _cdecl fxPatchUnpatchPgm(long PgmId);

	long _cdecl fxPgmIsLoadable(long PrtnId, void* pPgmText); // !!! returns 1 if success
	long _cdecl fxPgmQueryRequiredResources(void* pPgmText, PGMQUERY* pPgmInfo);
	// Wrong! long _cdecl fxPgmCanReplace(void* pPgmText, long ?, long ?);
	long _cdecl fxPgmLoad(long PrtnId, long* pPgmId, void* pPgmText);
	long _cdecl fxPgmIsRunning(long PgmId);
	long _cdecl fxPgmQueryProgram(long PgmId, PGMQUERY* pPgmInfo);
	long _cdecl fxPgmUnload(long PgmId);

	long _cdecl fxPgmStart(long PgmId);
	long _cdecl fxPgmStop(long PgmId);
	
	long _cdecl fxPgmRampup(long PgmId);
	long _cdecl fxPgmRampdown(long PgmId);

	long _cdecl fxPgmWetMix(long PgmId, long Value);
	long _cdecl fxPgmInputMix(long PgmId, long Value);
	long _cdecl fxPgmOutputMix(long PgmId, long Value);

	

	// Hehe, connects PgmIdAfter to PgmIdInsert and PgmIdInsert to
	// program PgmIdAfter was connected to (if there's) 
	long _cdecl fxPatchInsertAfter(long PgmIdAfter, long PgmIdInsert);

	// connects PgmIdInsert to PgmIdBefore and program was
	// connected to PgmIdBefore to PgmIdInsert (if there's) 
	long _cdecl fxPatchInsertBefore(long PgmIdBefore, long PgmIdInsert);

	// replace connections of PgmIdReplace with PgmIdWith
	long _cdecl fxPatchReplace(long PgmIdReplace, long PgmIdWith);

	// same as fxPatchChannel but without channels ;)
	long _cdecl fxPatchAddAfter(long PgmIdAfter, long PgmIdAdd);

	// same as fxPatchChannel but without channels ;)
	long _cdecl fxPatchBypass(long PgmId);

	// returns output(B) connected to input(A)
	long _cdecl fxPatchQueryInput(long PgmAId, short ChnAId, long* pPgmBId, short* pChnBId);
	
	// Not yet - too many arguments for me :(
	//long _cdecl fxPatchQueryOutput(long PgmId, short ChnId, void* p1, void* p2, void* p3, void* p4, void* p5);

	// selfexplaining
	long _cdecl fxPatchGetNumIO(long PgmId, long* pNumInputs, long* pNumOutputs);

	// returns Partition Id
	long _cdecl fxPgmWhichPartition(long PgmId);

	// returns Chip Id
	long _cdecl fxPgmWhichChip(long PgmId);

	/* Well, fxPgmCreatePortID loads "Ports" program,
	   keep in mind that ChipOutputs are inputs of Ports program and
	   ChipInputs are its outputs */
	long _cdecl fxPgmCreatePortID(long ChipId, long ChipOutputs, long ChipInputs, long* pPgmId);
	long _cdecl fxPgmFreePortID(long PgmId);

	//Both function return number of Hardware Instansces when bufSize = 0
	// pHwId is array of longs of bufSize size.
	long _cdecl hrmGetHardwareInstances(long bufSize, void* pHwId); //returns 0xB00B1E50 in pHwId
	long _cdecl mxrGetHardwareInstances(long bufSize, void* pHwId); //returns 0xCADE0000 in pHwId

	// Returns ChipId (0x2001) when feeding it with HWID_HRM
	long _cdecl hrmGetFXID(long HwId);

	// Returns HWID_ECARD (0xCADE0000) when feeding it with HWID_HRM
	long _cdecl hrmGetMXRID(long HwId);

	// Returns 0xABBA0000 when feeding it with HWID_HRM	
	long _cdecl hrmGetHRBID(long HwId);

	// Returns 0x49500000 when feeding it with HWID_HRM	
	long _cdecl hrmGetIPID(long HwId);

	// Returns 0x511D0000 when feeding it with HWID_HRM	
	long _cdecl hrmGetSMID(long HwId);

	// Returns 0x5E1D0000 when feeding it with HWID_HRM	
	long _cdecl hrmGetSEID(long HwId);

	// Returns 0x02 when feeding it with HWID_CADE	
	long _cdecl mxrGetMixerType(long HwId);

	// Allocates chip
	// e10fxsrv feeds Unk1 with 0x00, ChipVer with 0x0a, Unk2 with 0x08
	long _cdecl fxRsrcAllocChip(long ChipId, long Unk1, long ChipVer, long Unk2);

	// Creates new partition
	long _cdecl fxRsrcNewPartition(long ChipId, long* pPrtnId);

	// Allocates partition created with fxRsrcNewPartition
	long _cdecl fxRsrcAllocPartition(long PrtnId, PRTNRSRC* pPrtnRsrc);

	// Releases partition allocated with fxRsrcAllocPartition
	long _cdecl fxRsrcReleasePartition(long PrtnId);

	// Deletes paritition created with fxRsrcNewPartition
	long _cdecl fxRsrcDeletePartition (long PrtnId);

	// Destroy resources allocated with fxRsrcAllocChip
	long _cdecl fxRsrcDestroy (long ChipId);

	// Both functions return something in Info only if
	// we have allocated chip (0x2001) and partition (0x8001)
	long _cdecl fxRsrcQueryChip(long ChipId, CHIPQUERY* ChipInfo);
	long _cdecl fxRsrcQueryPartitionB(long PrtnId, PRTNQUERYB* PrtnInfo);
	
	// HwId must be HWID_ECARD (maybe also other ?)
	long _cdecl mxrSetControlValue(long HwId, long CtrlId, long Value);
	long _cdecl mxrGetControlValue(long HwId, long CtrlId);
	long _cdecl mxrGetControlDefaultValue(long HwId, long CtrlId);

	// I'm not shure what it is, i've seen only strings like "-1051756064" and "65535" - %-/
	long _cdecl mxrGetControlDisplayString(long HwId, long CtrlId, long bufSize, void* pBuffer);

	/* Eapssrm.dll Functions */ 
	
	// assignes midi channels or asio pairs to fxbuses (userstrips in sscene)  
	// HwId - must be HWID_ECARD
	// SrcId - one of MIDI Synth or ASIO
	// ChnId - MIDI Channel or ASIO Pair
	// RouitingID - FXRT Buses (left, right, fxsend1 or fxsend2)
	// DestBusId - Destination FXBus
	long _cdecl srmAssignMIDIChannelSendToFXEngInput(long HwId, long SrcId, long ChnId, long RoutingId, long DstBusId);
	
	// i don't know what this function does
	// sscene feeds it with:
	// unk1 - 2f, 30, 31, 23, 24, 21, 22 etc.
	// unk2 - 01, 0e, 0f, ff, ff, 00, 00 etc.
	// i don't see any logic and don't hear any changes in sound :( 
	long _cdecl srmSetWaveChannelSoundEngineParameter(long HwId, long Reserved, long unk1, long unk2);  // Resrved is always = 0x00
     
    // Not Yet...
    // srmSetMIDIChannelMasterAmount
    // srmSetWaveChannelMode - nobody in aps drivers call this ?!
    
	} // end of extern "C"


	/* Some Wrappers/Macros */
	// You should carefuly understand this macros
	#define fxParamReadInstruction(PgmId, InstrId, Instr) fxParamReadInstructionB((PgmId), (InstrId), ((E10FXINSTRB*) &(Instr.Opcode)))
	#define fxRsrcQueryPartition(PrtnId, PrtnInfo) fxRsrcQueryPartitionB((PrtnId), ((PRTNQUERYB*) &(PrtnInfo.Instructions)))

	/* Aps15Api functions */
	long hrmInitHwIds(void); // this fun replaced InitAps15Api

	/* Public E-mu Hardware identifiers (handles) used to call Aps15Api */
	/* To use this identifiers you must call hrmInitHwIds first */
	extern long HWID_HRM;			/* returned by hrmGetHardwareInstances */
	extern long HWID_ECARD;		/* returned by mxrGetHardwareInstances */
	extern long HWID_EDRIVE;		/* returned by mxrGetHardwareInstances
									but on Live! = 0x00000000 */
	extern long HWID_MULTIOUT;		/* multioutcard - returned by mxrGetHardwareInstances
									but on Live! = 0x00000000 */

	/* also ChipId (0x2001) is also here
		maybe it's not good, but ... */
	extern long HWID_CHIP;		/* returned by hrmGETFXID


	/* APS15API Errors*/
	#define APS_SUCCESS			0x00000000
	#define APS_INVALIDID		0x00000006
	#define APS_INVALIDCHIP		0x00000019
	#define APS_INVALIDHWID		0x00000021
	#define APS_ERR_HARDWARE	0x00001001

	/* Common Constants */
	#define FXCHIP_BASE				0x00002000
	#define FXPROGRAM_BASE			0x00004000
	#define FXPARTITION_BASE		0x00008000

	/* RegId Flags */
	#define RID_VIRTUAL			0x00008000	// Static (incl Output) returned as virtual
											// but temp/(dynamic) as general purpose

	/* Field Flags used for InstrField arguments of
	   fxParamRead/WriteInstructionField functions */
	#define	FF_Opcode		0x0000
	#define	FF_A			0x2000
	#define	FF_X			0x4000
	#define	FF_Y			0x6000
	#define	FF_R			0x8000

	/* Ports I/O (used in fxPgmCreatePortID) */
	// ChipOutputs (Ports Inputs)
	#define CO_OUT0L		0x00000001
	// etc. we don't even need to know these Ids since we will use all ;)
	#define CO_ALL			0xffffffff
	// ChipInputs (Ports Outputs)
	#define CI_ALL			0xffffffff


	/* Tank Memory Address Registers Flags
	   (used in Param Read/Write Flags) */
	#define  TRAM_READ		0x00	// Read form TRAM - flag 0x01 in TramAddrRegister(TAR)
	#define  TRAM_WRITE		0x01	// Write to TRAM - 0x02 in TAR
	#define  TRAM_ADD		0x02	// "RSAW - Read Sum And Write" - data is added to data already in TRAM - 0x03 in TAR
	#define  TRAM_TREAD		0x03	// TableLookUp ?? - flag 0x00 in TAR, i still can't use it
	#define  TRAM_CLEAR		0x04	// Clear TRAM 

	/* Control Identifiers (used in mxrGet/SetControlValue 
	   and GetControlDisplayString as CtrlId), valid for APS only */
	// there are also other controls (i guess even "serial number" is control ;)
	// but i can't find them (on CT4832 ?! :p)
	#define  CID_ANINGAIN	0x0C	// Analog Input Gain (for 1 and 2)
									// Gain range 0x00 - 0xFF
									// Value is short 0xXXYY where XX is gain of A1IN
									// and YY is gain of A2IN
	#define  CID_D1INSRC	0x0D	// to switch DigitalIn1 phisical source
	#define  CID_D2INSRC	0x0E	// to switch DigitalIn2 phisical source

	/* Control Values (used in mxrGet/SetControlValue 
	   and GetControlDisplayString as Value), valid for APS only */
	#define  CV_SPDIFIN1	0x0000
	#define  CV_SPDIFIN2	0x0001	
	#define  CV_SPDIFCD		0x0004  

	/* MIDI Synthesizers and ASIO Playback Sources(used in srmAssignMIDIChannelSendToFXEngInput) */
	/* maybe there are some other sources (WAVEPLAYBACK etc.) ... */
	#define MIDISYNTH_A		0x00000000
	#define MIDISYNTH_B		0x00000001
	#define ASIOPLAYBACK	0xA510A510	//;)

	/* MIDI Channels and ASIO Playback Buses (used in srmAssignMIDIChannelSendToFXEngInput) */
	/* needs checking!!! */
	#define MIDICH1			0x00
	#define MIDICH2			0x01
	#define MIDICH3			0x02
	#define MIDICH4			0x03
	#define MIDICH5			0x04
	#define MIDICH6			0x05
	#define MIDICH7			0x06
	#define MIDICH8			0x07
	#define MIDICH9			0x08
	#define MIDICH10		0x09
	#define MIDICH11		0x0A
	#define MIDICH12		0x0B
	#define MIDICH13		0x0C
	#define MIDICH14		0xOD
	#define MIDICH15		0x0E
	#define MIDICH16		0x0F

	#define ASIOPLAY1		0x00
	#define ASIOPLAY2		0x01
	#define ASIOPLAY3		0x02
	#define ASIOPLAY4		0x03
	#define ASIOPLAY5		0x04
	#define ASIOPLAY6		0x05
	#define ASIOPLAY7		0x06
	#define ASIOPLAY8		0x07
	#define ASIOPLAY9		0x08
	#define ASIOPLAY10		0x09
	#define ASIOPLAY11		0x0A
	#define ASIOPLAY12		0x0B

	/* MIDI Channels Send Buses and ASIO Playback Channels, also called Routings */
	/* (used in srmAssignMIDIChannelSendToFXEngInput) */
	/* see FXRT registers in 8010.h - that's it */
	#define SEND_LEFT		0x00	
	#define SEND_RIGHT		0x01
	#define FXSEND_1		0x02	/* only for midi - CC91 */
	#define FXSEND_2		0x03	/* only for midi - CC93 */

	/* FX8010 FXBUSes or Outputs of abstract FXEngine's program "Ports" */
	/* (used in srmAssignMIDIChannelSendToFXEngInput) */
	#define FXBUS0		0x00
	#define FXBUS1		0x01
	#define FXBUS2		0x02
	#define FXBUS3		0x03
	#define FXBUS4		0x04
	#define FXBUS5		0x05
	#define FXBUS6		0x06
	#define FXBUS7		0x07	
	#define FXBUS8		0x08	
	#define FXBUS9		0x09	
	#define FXBUSA		0x0A	
	#define FXBUSB		0x0B	
	#define FXBUSC		0x0C	
	#define FXBUSD		0xOD	
	#define FXBUSE		0x0E	
	#define FXBUSF		0x0F	


	#endif	/* _APS15API_ */